// HatchFill.h
//
// Header file for the CHatchFill class
//////////////////////////////////////////////
#ifndef HATCHFILL
#define HATCHFILL

#include <afx.h>
#include <afxwin.h>

#ifdef _ALIUSE
// Include version info
	#include "..\Versions\versions.h"
#else
	#include "Versions.h"
#endif

//#include "..\wsconverter\fntoutln.h"
//#include "..\GrEngine\GrEngine.h"

#define HF_TEMP_FILE	"Fill.tmp"

#define HF_SIZE 1000

#define STATE_OFF	0
#define STATE_ON	1

#ifndef PI
	#define PI	3.14159265359
#endif


/// 1.0242 DAN 9/2/99 NEW HATCHFILL ADDITION FIRST REVISION ///
// Arc Resolution Styles
#define HF_AR_ADAPTIVE	0
#define HF_AR_FIXED		1
////1.0242/////////////////////////////////////////////////////


//// 1.0985 PAT 31.01.05 FILL INTERLACING ////
#define HF_INTERLACE_MIN	1
#define HF_INTERLACE_MAX	1000
//// 1.0985 //////////////////////////////////

class CHatchFill : public CObject
{
	DECLARE_SERIAL( CHatchFill )

// Attributes
public:
	/// 1.0242 DAN 9/2/99 NEW HATCHFILL ADDITION FIRST REVISION ///
	long	m_lArcPolyLength;
	UINT	m_nArcResStyle;
	////1.0242/////////////////////////////////////////////////////

	/// 1.0262 DAN 12/13/99 LIVE FILL SELECTION ///
	BOOL	m_bLiveFill;
	////1.0262/////////////////////////////////////

	UINT	m_nVersion;
	// Valid flag
	UINT	m_bValidFill;

	// Fill information
	UINT	m_bTTFilled;		// True Type filled font
	int		m_iFillSpacing;		// Fill Spacing
	int		m_iFillAngle;		// Fill Angle
	int		m_iBeamWidth;		// Beam Width


	//// 1.0732 DAN 06.04.07 CROSS HATCH ////
	int m_iNumCrossAngles;
	int m_iFillAngle1;
	int m_iFillAngle2;
	int m_iFillAngle3;
	int m_iFillAngle4;
	int m_iFillAngle5;
	//// 1.0732 /////////////////////////////


	/// 1.0290 DAN 4/25/00 BI-DIRECTIONAL FILL ///
	BOOL	m_bBiDirectional;	// Bi Directional fill
	////1.0290////////////////////////////////////

	//// 1.0985 PAT 31.01.05 FILL INTERLACING ////
	UINT	m_nInterlace;
	//// 1.0985 //////////////////////////////////

	CDC *m_pMemDC;
	CBitmap *m_pMemBitmap,
			*m_pTempBitmap;
	CBrush	*m_pTempBrush;
	CPen	*m_pTempPen;
	CPen	*m_pBeamPen;

	int m_iSize;

//	CFontOutline g_fo;

	COLORREF	m_crBackGround;

	int		m_iMinX,
			m_iMaxX,
			m_iMinY,
			m_iMaxY;

	CObject *m_pDaVinci;

	CString m_sFont;

	// conversion to size parameter
	long double	m_ldCharRatio;
	// X compression
	long double m_ldXComp;

	/// 1.0242 DAN 9/2/99 NEW HATCHFILL ADDITION FIRST REVISION ///
	///// The object array used for storing the fill
	///CObArray	m_FontFill;
	////1.0242/////////////////////////////////////////////////////

// Operators
public:
	// Contructor / Destructor
	CHatchFill(void);
	~CHatchFill(void);
	void Init(void);	// Initiallize
	
	/*** 1.0035 PAT 12.05.98 = & == CLEAN UP ***/
	void operator =( const CHatchFill& );
	BOOL operator ==( const CHatchFill& );
	/*******************************************/

	void Serialize(CArchive& ar);

	// Delete all the fills
	void DeleteFills(void);

	// Creates a memory DC for drawing and computing the hatch fill of
	// an object that is drawn using the windows path feature
	void CreateMemDC(CDC *pDC, int iSize, int iBeamWidth);

	// Destroys and deallocates all items associated with a 
	// memory device context
	void DestroyMemDC();

	void DrawFilledChar(CDC *pDC, _TXCHAR cChar, long *pSymbol);

	int DrawHatch(long double ldHatchSpacing, int iAngle, FILE *fp);

	void FillChar(CDC *pDC, long lHeight, long double ldXComp, _TUCHAR cChar, long *pSymbol);

	int Round(long double ldIn);
};




#endif //HATCHFILL