// LM45_constants.h

// This file contains definitions of constants used
// in the CLM45 class
//
// Pat Summers
// American LaserWare, Inc.

#ifndef LM45_CONSTANTS
#define LM45_CONSTANTS

// QSwitch Modes
const BOOL LM45_QSMODE_CW					=	TRUE;
const BOOL LM45_QSMODE_PULSED				=	FALSE;

// Specs
const int	LM45_SPEC_PUMP_PRIMECOUNT_MAX	=	10;
const float LM45_SPEC_WATER_TEMP_MAX		=	35.0f;
const float LM45_SPEC_WATER_TEMP_MIN		=	25.0f;
const float LM45_SPEC_WATER_COND_MIN		=	3.0f;
const float LM45_SPEC_QSD_FREQ_MIN			=	1.0f;
const float LM45_SPEC_QSD_FREQ_MAX			=	50.0f;
const float LM45_SPEC_PS_CURRENT_MIN		=	6.0f;
const float LM45_SPEC_PS_CURRENT_MAX		=	20.0f;
/*** REV L007 - 19990715 - HENE/LAMP CURRENT LIMIT ***/
const float LM45_SPEC_PS_CURRENT_THRESHOLD	=	6.25f;
	// This value is NOT the min current setting.
	// It is used as the limit to decide if a reported
	// ADC value for lamp current is at min. level.
	// The schematics call for 6.5A.  Use 6.25 to be
	// safe.
/*** REV L007 ****************************************/

// ADC states
const int LM45_ADCSTATE_IDLE				=	0;
const int LM45_ADCSTATE_WAITONPREV			=	1;
const int LM45_ADCSTATE_START				=	2;
const int LM45_ADCSTATE_BUSY				=	3;

const int LM45_ADCSTATE_BUSYWATERTEMP		=	3;
const int LM45_ADCSTATE_BUSYWATERCOND		=	4;
const int LM45_ADCSTATE_BUSYLAMPCURRENT		=	5;

#endif	// LM45_CONSTANTS
