// RTC3 Constants
//
/////////////////////////////////////

// RTC3Constants.h

// This file contains definitions for the RTC3 board

//// 1.0445 PAT 11.10.00 RTC3 DRIVER ////
// Added this file
//// 1.0445 /////////////////////////////

#ifndef RTC3CONSTANTS
#define RTC3CONSTANTS

#define RTC3_DLLNAME_DEFAULT				_T("RTC3DLL.DLL")
#define RTC3_DLLNAME_NOTLOADED				_T("NOT LOADED")

#define	RTC3_PROGNAME_DEFAULT				_T("RTC3D2.HEX")

#define	RTC3_CTBNAME_DEFAULT				_T("COR_1TO1.CTB")

const UINT				RTC3_CTB_NUM			=	2;
const UINT				RTC3_CTB_MIN			=	0;
const UINT				RTC3_CTB_MAX			=	1;

const double			RTC3_CTB_GAIN_MIN		=	0.8;
const double			RTC3_CTB_GAIN_MAX		=	1.2;
const int				RTC3_CTB_OFFSET_MIN		=	-30000;
const int				RTC3_CTB_OFFSET_MAX		=	30000;
const int				RTC3_CTB_ROT1_MIN		=	-10;
const int				RTC3_CTB_ROT1_MAX		=	10;
const int				RTC3_CTB_ROT90_MIN		=	0;
const int				RTC3_CTB_ROT90_MAX		=	3;

//// 1.0581 PAT 06.08.01 RTC3 FIXES ////
const int				RTC3_CTB_FILE_SIZE_3D	=	17000;
//// 1.0581 ////////////////////////////

const unsigned short	RTC3_OPT_FLY			=	0x0100;
const unsigned short	RTC3_OPT_2HEADS			=	0x0200;
const unsigned short	RTC3_OPT_3D				=	0x0400;
const unsigned short	RTC3_OPT_IO				=	0x0800;

const UINT	RTC3_HEAD_A							=	0;
const UINT	RTC3_HEAD_B							=	1;
const UINT	RTC3_HEAD_NUM						=	2;
const UINT	RTC3_HEAD_MODE_OFF					=	0;	// Always off
const UINT	RTC3_HEAD_MODE_1_1					=	1;	// Always CTB 1
const UINT	RTC3_HEAD_MODE_2_2					=	2;	// Always CTB 2
const UINT	RTC3_HEAD_MODE_1_2					=	3;	// 1=Mark / 2=Setup
const UINT	RTC3_HEAD_MODE_2_1					=	4;	// 2=Mark / 1=Setup

const UINT	RTC3_CARD_MAX						=	1;
const UINT	RTC3_CARD_DEFAULT					=	1;

const UINT	RTC3_LIST_MAX						=	3990;
const UINT	RTC3_LIST_FLUSHLIMIT				=	3500;
const UINT	RTC3_LIST_START1					=	0;
const UINT	RTC3_LIST_START2					=	4000;

const UINT	RTC3_VERSION_DEFAULT				=	0;

const UINT	RTC3_LASERTYPE_CO2					=	0;
const UINT	RTC3_LASERTYPE_YAG1					=	1;
const UINT	RTC3_LASERTYPE_YAG2					=	2;
//// 1.0921 PAT 19.08.04 IPG LASER ////
const UINT	RTC3_LASERTYPE_YAG3					=	3;
const UINT	RTC3_LASERTYPE_MODE4				=	4;
//// 1.0921 ///////////////////////////
const UINT	RTC3_LASERTYPE_DEFAULT				=	RTC3_LASERTYPE_CO2;

const UINT	RTC3_ARCRES_MIN						=	1;
const UINT	RTC3_ARCRES_MAX						=	10000;
const UINT	RTC3_ARCRES_DEFAULT					=	100;

const unsigned short	RTC3_STATUS_NOTBUSY		=	0x0000;
const unsigned short	RTC3_STATUS_LOAD1		=	0x0001;
const unsigned short	RTC3_STATUS_LOAD2		=	0x0002;
const unsigned short	RTC3_STATUS_READY1		=	0x0004;
const unsigned short	RTC3_STATUS_READY2		=	0x0008;
const unsigned short	RTC3_STATUS_BUSY1		=	0x0010;
const unsigned short	RTC3_STATUS_BUSY2		=	0x0020;

const unsigned short	RTC3_CONTROLMODE_DEFAULT	=	0x0000;
	// Only bit 0 is used.  Bit 0 = 0 disables the
	// hardware START input signal.  If enabled,
	// RTC3 could start without ProLase knowing.
//// 1.0499 PAT 19.02.00 RTC START/STOP ////
const unsigned short	RTC3_CONTROLMODE_NOEXTSTART	=	0x0000;
const unsigned short	RTC3_CONTROLMODE_EXTSTART	=	0x0001;
//// 1.0499 ////////////////////////////////


const unsigned short	RTC3_LISTMODE_NORMAL	=	0;
const unsigned short	RTC3_LISTMODE_RINGMODE	=	1;
const unsigned short	RTC3_LISTMODE_DEFAULT	=	RTC3_LISTMODE_NORMAL;

// MIN/MAX
const unsigned short	RTC3_JUMPDELAY_MIN		=	0;
const unsigned short	RTC3_JUMPDELAY_MAX		=	65500;
	// 1 bit = 10 us
const unsigned short	RTC3_MARKDELAY_MIN		=	0;
const unsigned short	RTC3_MARKDELAY_MAX		=	65500;
	// 1 bit = 10 us
const unsigned short	RTC3_POLYDELAY_MIN		=	0;
const unsigned short	RTC3_POLYDELAY_MAX		=	65500;
	// 1 bit = 10 us
const unsigned short	RTC3_POLYDELAYLIMIT_MIN	=	0;
const unsigned short	RTC3_POLYDELAYLIMIT_MAX	=	65499;
const unsigned short	RTC3_POLYDELAYLIMIT_OFF	=	65500;
	// 1 bit = 10 us

const unsigned short	RTC3_LASEROFFDELAY_MIN	=	2;
const unsigned short	RTC3_LASEROFFDELAY_MAX	=	8000;
	// 1 bit = 1 us
//// 1.0737 PAT 09.12.02 RTC3 NEG LASERON DELAY ////
//	const unsigned short	RTC3_LASERONDELAY_MIN	=	2;
const short	RTC3_LASERONDELAY_MIN	=	-8000;
//// 1.0737 ////////////////////////////////////////
const unsigned short	RTC3_LASERONDELAY_MAX	=	8000;
	// 1 bit = 1 us

const double			RTC3_JUMPSPEED_MIN		=	1.0;
const double			RTC3_JUMPSPEED_MAX		=	50000.0;
const double			RTC3_JUMPSPEED_DEFAULT	=	10000.0;
	// in bits/ms
const double			RTC3_MARKSPEED_MIN		=	1.0;
const double			RTC3_MARKSPEED_MAX		=	50000.0;
const double			RTC3_MARKSPEED_DEFAULT	=	2500.0;
	// in bits/ms

const unsigned short	RTC3_STANDBY_HALFPER_MIN =	0;
const unsigned short	RTC3_STANDBY_HALFPER_MAX =	65500;
	// 1 bit = 1/8 us
const unsigned short	RTC3_STANDBY_WIDTH_MIN	=	0;
const unsigned short	RTC3_STANDBY_WIDTH_MAX	=	65500;
	// 1 bit = 1/8 us
const unsigned short	RTC3_FPS_WIDTH_MIN		=	0;
const unsigned short	RTC3_FPS_WIDTH_MAX		=	65500;
	// 1 bit = 1/8 us

const unsigned short	RTC3_TIMEBASE_1MHZ		=	0;
const unsigned short	RTC3_TIMEBASE_8MHZ		=	1;
	// 8 MHZ clock for any non-zero value
const unsigned short	RTC3_LASER_HALFPER_MIN	=	2;
const unsigned short	RTC3_LASER_HALFPER_MAX	=	65500;
	// 1 bit = 1 us or 1/8 us
const unsigned short	RTC3_LASER_WIDTH_MIN	=	2;
const unsigned short	RTC3_LASER_WIDTH_MAX	=	65500;
	// 1 bit = 1 us or 1/8 us

const double			RTC3_TIMERES_SCANNER_DELAY	=	0.1;
	// 1 bit = 10 us
const double			RTC3_TIMERES_LASER_DELAY	=	1.0;
const double			RTC3_TIMERES_1MHZ			=	1.0;
	// 1 bit = 1 us
const double			RTC3_TIMERES_FPS			=	8.0;
const double			RTC3_TIMERES_STANDBY_HALFPER=	8.0;
const double			RTC3_TIMERES_STANDBY_WIDTH	=	8.0;
const double			RTC3_TIMERES_8MHZ			=	8.0;
	// 1 bit = 1/8 us

//// 1.0561 PAT 20.06.01 RTC WOBBLE ADDITIONS ////
const unsigned short	RTC3_WOBBLE_AMP_OFF			=	0;
const unsigned short	RTC3_WOBBLE_AMP_MIN			=	1;
const unsigned short	RTC3_WOBBLE_AMP_MAX			=	2;

const double			RTC3_WOBBLE_FREQ_MIN		=	1.0;
const double			RTC3_WOBBLE_FREQ_MAX		=	6000.0;
//// 1.0561 //////////////////////////////////////

const unsigned short	RTC3_PIXEL_MODE_0			=	0;
const unsigned short	RTC3_PIXEL_MODE_1			=	1;
const unsigned short	RTC3_PIXEL_MODE_DEFAULT		=	RTC3_PIXEL_MODE_1;
const double			RTC3_PIXEL_PERIOD_FACTOR	=	0.1;
const unsigned short	RTC3_PIXEL_PW_MASK			=	0x00ff;
const unsigned short	RTC3_PIXEL_PW_FACTOR		=	8;
const unsigned short	RTC3_PIXEL_DAC_MASK			=	0xff00;
const unsigned short	RTC3_PIXEL_DAC_SHIFT		=	6;

const unsigned short	RTC3_PIXEL_ADC_NONE			=	0;
const unsigned short	RTC3_PIXEL_ADC_1			=	1;
const unsigned short	RTC3_PIXEL_ADC_2			=	2;
const unsigned short	RTC3_PIXEL_ADC_3			=	3;



const UINT				RTC3_FIELD_BITS				=	65535;
const UINT				RTC3_DAC_MAX				=	0x03ff;
const UINT				RTC3_DACPORTS_MIN			=	1;
//// 1.0631 PAT 07.02.02 RTC3 FOCUS CONTROL ////
//	const UINT				RTC3_DACPORTS_MAX			=	2;
const UINT				RTC3_DACPORTS_MAX			=	6;
const unsigned short	RTC3_DAC_CHANNEL_POWER		=	1;
//// PS090924A ANALOG FREQ CONTROL IN RTC ////
const unsigned short	RTC3_DAC_CHANNEL_FREQ		=	2;
//// PS090924 ////////////////////////////////
const unsigned short	RTC3_DAC_CHANNEL_RASTER		=	2;
const unsigned short	RTC3_DAC_CHANNEL_FOCUS		=	5;
//// 1.0631 ////////////////////////////////////
const short				RTC3_Z_MAX					=	32767;

//// 1.0503 PAT 22.02.01 RTC3 LASER EXTENSION ////
const UINT				RTC3_LASEREXT_MAX			=	0x00ff;
//// 1.0503 //////////////////////////////////////

//// 1.0897 PAT 17.06.04 RTC DELAYS ADDIN ////
const unsigned short	RTC3_JUMPMIN_MAX			=	32500;
const unsigned short	RTC3_JUMPLIMIT_MAX			=	32500;
//// 1.0897 //////////////////////////////////

// Errors
// RTC3 functions return codes are positive,
// so we use negative values
const int				RTC3_ERR_NOERROR			=	0;
const int				RTC3_ERR_NOFUNCTION			=	-1;
const int				RTC3_ERR_BADINPUT			=	-2;


// Versions
const UINT				RTC3_VER_HARDWARE_DEFAULT	=	0;
const UINT				RTC3_VER_SOFTWARE_DEFAULT	=	0;
const UINT				RTC3_VER_DLL_DEFAULT		=	0;
const UINT				RTC3_VER_SERIAL_DEFAULT		=	0;

// On-the-fly
const double			RTC3_FLY_PPI_DEFAULT		=	250.0;
#define					RTC3_FLY_PPI_UNITS_BASE		_T("lines / ")
const double			RTC3_FLY_CPI_DEFAULT		=	1000.0;
#define					RTC3_FLY_CPI_UNITS_BASE		_T("counts / ")
const double			RTC3_FLY_K_DEFAULT			=	2.0;

const UINT				RTC3_FLY_AXIS_NUM			=	2;
const UINT				RTC3_FLY_AXIS_X				=	0;
const UINT				RTC3_FLY_AXIS_Y				=	1;

// 3D
const double			RTC3_3D_A_DEFAULT			=	0.0;
const double			RTC3_3D_B_DEFAULT			=	0.0;
const double			RTC3_3D_C_DEFAULT			=	0.0;
const double			RTC3_3D_ZOFFSET_DEFAULT		=	0.0;

//// 1.0499 PAT 19.02.00 RTC START/STOP ////
const unsigned short	RTC3_STARTSTOP_MASK_INTSTART	=	0x0001;
const unsigned short	RTC3_STARTSTOP_MASK_EXTSTART	=	0x0002;
const unsigned short	RTC3_STARTSTOP_MASK_INTSTOP		=	0x0004;
const unsigned short	RTC3_STARTSTOP_MASK_EXTSTOP		=	0x0008;
//// 1.1031 PAT 12.07.05 RTC3/4 EXT START ////
const unsigned short	RTC3_STARTSTOP_MASK_EXTSTOPLEVEL=	0x0010;
//// 1.1031 //////////////////////////////////
const unsigned short	RTC3_STARTSTOP_MASK_RESERVED	=	0x0100;
const unsigned short	RTC3_STARTSTOP_MASK_LASERENABLED=	0x0200;
const unsigned short	RTC3_STARTSTOP_MASK_LASERACTIVELO=	0x0400;
//// 1.0499 ////////////////////////////////
//// 1.1031 PAT 12.07.05 RTC3/4 EXT START ////
const unsigned short	RTC3_STARTSTOP_MASK_EXTSTARTLEVEL=	0x1000;
//// 1.1031 //////////////////////////////////

//// 1.0501 PAT 21.02.01 RTC DIO ////
const unsigned short	RTC3_DIO_IN_MASK			=	0xff00;
const int				RTC3_DIO_IN_SHIFT			=	8;
const unsigned short	RTC3_DIO_OUT_MASK			=	0xff00;
const int				RTC3_DIO_OUT_SHIFT			=	8;
//// 1.0501 /////////////////////////

//// 1.0503 PAT 22.02.01 RTC3 LASER EXTENSION ////
const unsigned short	RTC3_LASEREXT_MASK			=	0x00ff;
//// 1.0503 //////////////////////////////////////

//// 1.0651 PAT 02.04.02 RTC3 LASER EXT GP DIG OUT ////
const int				RTC3_DIOMODE_DDA			=	0;
const int				RTC3_DIOMODE_IOEXT			=	1;
const int				RTC3_DIOMODE_LASEREXT		=	2;

const int				RTC3_DIOMODE_DEFAULT		=	RTC3_DIOMODE_DDA;
//// 1.0651 ///////////////////////////////////////////

//// 1.0919 PAT 08.08.04 PORT C DIO FIX ////
const unsigned short	RTC3_DIO_IN_MASK_PROLASE	=	0xff0f;
const unsigned short	RTC3_DIO_OUT_MASK_PROLASE	=	0xfff0;
//// 1.0919 ////////////////////////////////

//// 1.1263 PAT 13.11.06 RTC FOCUS CONTROL ////
const unsigned short	RTC3_ANALOG_1_MODE_POWER	=	0;
const unsigned short	RTC3_ANALOG_1_MODE_FOCUS	=	1;
//// 1.1263 ///////////////////////////////////

//// 1.1023 PAT 03.06.05 RTC 3D OPTION FIX ////
const unsigned short	RTC3_VER_SOFT_3D_MIN		=	3000;
//// 1.1023 PAT ///////////////////////////////
#endif	//RTC3CONSTANTS
