// Header file for the CRTC4CTBXform class
//
// RTC4CTBXform.h

// This class is the data structure for holding data
// for transforming the Correction file data for an
// RTC4 board

//// 1.0835 PAT 02.03.04 RTC4 ////
// Added this file
//// 1.0835 //////////////////////

#ifndef CRTC4CTBXFORM
#define CRTC4CTBXFORM

#include <afx.h>

#define RTC4CTBXFORM_2000_10_11			0

#define VER_RTC4CTBXFORM				RTC4CTBXFORM_2000_10_11

#ifdef _ALIUSE
	#include ".\RTC4Constants.h"
#else
	#include "RTC4Constants.h"
#endif

class CRTC4CTBXform : public CObject
{

	DECLARE_SERIAL( CRTC4CTBXform )

// Attributes
private:
	// Version info
	UINT
		m_nVersion;
public:
	double
		m_dGainX,
		m_dGainY,
		m_dOffsetX,
		m_dOffsetY,
		m_dRot;
		
// Implementations
public:
	CRTC4CTBXform(void);
	~CRTC4CTBXform(void);

	void Init(void);

    void Serialize( CArchive& ar );

// Operators
	void operator =( const CRTC4CTBXform& src );
	BOOL operator ==( const CRTC4CTBXform& src );
public:
};

#endif // CRTC4CTBXFORM

