// RTCSA4DLL_TYPE.h
//
// This file contains the type declarations
// for the functions in the RTCSA4 DLL that
// are made accessible to ProLase

//// 1.1037 PAT 25.07.05 SCANALONE ////
// Added this file
//// 1.1037 ///////////////////////////
#pragma once

#ifndef RTCSA4DLL_TYPE
#define RTCSA4DLL_TYPE

typedef long (__stdcall *SA4_USB_STATUS)(void);
typedef short (__stdcall *SA4_LOAD_CORRECTION_FILE)(const char* filename, short cortable, double kx, double ky, double phi, double xoffset, double yoffset);
typedef short (__stdcall *SA4_LOAD_COR)(const char* filename);
typedef short (__stdcall *SA4_LOAD_PROGRAM_FILE)(const char* name);
typedef short (__stdcall *SA4_LOAD_PRO)(const char* filename);
typedef short (__stdcall *SA4_LOAD_VARPOLYDELAY)(const char* stbfilename, unsigned short tableno);
typedef short (__stdcall *SA4_LOAD_Z_TABLE)(double a, double b, double c);
typedef void (__stdcall *SA4_GET_WAVEFORM)(unsigned short channel, unsigned short stop, unsigned short memptr);
typedef void (__stdcall *SA4_GET_STATUS)(unsigned short *busy, long *position);
typedef unsigned short (__stdcall *SA4_READ_STATUS)(void);
typedef unsigned short (__stdcall *SA4_GET_DLL_VERSION)(void);
typedef long (__stdcall *SA4_GET_INPUT_POINTER)(void);
typedef void (__stdcall *SA4_SET_INPUT_POINTER)(long pointer);
typedef void (__stdcall *SA4_SET_START_LIST_1)(void);
typedef void (__stdcall *SA4_SET_START_LIST_2)(void);
typedef void (__stdcall *SA4_SET_START_LIST)(unsigned short listno);
typedef void (__stdcall *SA4_EXECUTE_LIST_1)(void);
typedef void (__stdcall *SA4_EXECUTE_LIST_2)(void);
typedef void (__stdcall *SA4_EXECUTE_LIST)(unsigned short listno);
typedef void (__stdcall *SA4_WRITE_8BIT_PORT)(unsigned short value);
typedef void (__stdcall *SA4_WRITE_IO_PORT)(unsigned short value);
typedef void (__stdcall *SA4_AUTO_CHANGE)(void);
typedef void (__stdcall *SA4_AUT_CHANGE)(void);
typedef void (__stdcall *SA4_START_LOOP)(void);
typedef void (__stdcall *SA4_QUIT_LOOP)(void);
typedef void (__stdcall *SA4_STOP_EXECUTION)(void);
typedef void (__stdcall *SA4_DSP_START)(void);
typedef unsigned short (__stdcall *SA4_READ_IO_PORT)(void);
typedef void (__stdcall *SA4_WRITE_DA_1)(unsigned short value);
typedef void (__stdcall *SA4_WRITE_DA_2)(unsigned short value);
typedef void (__stdcall *SA4_WRITE_DA_X)(unsigned short x, unsigned short value);
typedef void (__stdcall *SA4_SET_MAX_COUNTS)(long counts);
typedef long (__stdcall *SA4_GET_COUNTS)(void);
typedef void (__stdcall *SA4_SET_MATRIX)(double m11, double m12, double m21, double m22);
typedef void (__stdcall *SA4_SET_OFFSET)(short xoffset, short yoffset);
typedef void (__stdcall *SA4_GOTO_XY)(short x, short y);
typedef void (__stdcall *SA4_GOTO_XYZ)(short x, short y, short z);
typedef unsigned short (__stdcall *SA4_GET_HEX_VERSION)(void);
typedef void (__stdcall *SA4_ENABLE_LASER)(void);
typedef void (__stdcall *SA4_DISABLE_LASER)(void);
typedef void (__stdcall *SA4_STOP_LIST)(void);
typedef void (__stdcall *SA4_RESTART_LIST)(void);
typedef unsigned short (__stdcall *SA4_GET_RTC_VERSION)(void);
typedef void (__stdcall *SA4_GET_XY_POS)(short *x, short *y);
typedef void (__stdcall *SA4_GET_XYZ_POS)(short *x, short *y, short *z);
typedef void (__stdcall *SA4_SELECT_LIST)(unsigned short list_2);
typedef void (__stdcall *SA4_SET_EXTSTARTPOS)(long position);
typedef void (__stdcall *SA4_Z_OUT)(short z);
typedef void (__stdcall *SA4_SET_FIRSTPULSE_KILLER)(unsigned short fpk);
typedef void (__stdcall *SA4_SET_STANDBY)(unsigned short half_period, unsigned short pulse);
typedef void (__stdcall *SA4_LASER_SIGNAL_ON)(void);
typedef void (__stdcall *SA4_LASER_SIGNAL_OFF)(void);
typedef void (__stdcall *SA4_SET_DELAY_MODE)(unsigned short varpoly, unsigned short directmove3d, unsigned short edgelevel, unsigned short minjumpdelay, unsigned short jumplengthlimit);
typedef void (__stdcall *SA4_SET_PISO_CONTROL)(unsigned short l1, unsigned short l2);
typedef void (__stdcall *SA4_SELECT_STATUS)(unsigned short mode);
typedef void (__stdcall *SA4_GET_ENCODER)(short *zx, short *zy);
typedef void (__stdcall *SA4_SELECT_COR_TABLE)(unsigned short heada, unsigned short headb);
typedef void (__stdcall *SA4_EXECUTE_AT_POINTER)(long position);
typedef unsigned short (__stdcall *SA4_GET_HEAD_STATUS)(unsigned short head);
typedef void (__stdcall *SA4_SIMULATE_ENCODER)(unsigned short channel);
typedef void (__stdcall *SA4_RELEASE_WAIT)(void);
typedef unsigned short (__stdcall *SA4_GET_WAIT_STATUS)(void);
typedef void (__stdcall *SA4_SET_CONTROL_MODE)(unsigned short mode);
typedef void (__stdcall *SA4_SET_LASER_MODE)(unsigned short mode);
typedef void (__stdcall *SA4_SET_EXT_START_DELAY)(short delay, short encoder);
typedef void (__stdcall *SA4_HOME_POSITION)(short xhome, short yhome);
typedef unsigned short (__stdcall *SA4_READ_AD_X)(unsigned short x);
typedef short (__stdcall *SA4_GET_Z_DISTANCE)(short x, short y, short z);
typedef unsigned short (__stdcall *SA4_GET_STARTSTOP_INFO)(void);
typedef unsigned short (__stdcall *SA4_GET_IO_STATUS)(void);
typedef double (__stdcall *SA4_GET_TIME)(void);
typedef void (__stdcall *SA4_SET_DEFOCUS)(short value);
typedef void (__stdcall *SA4_SET_SOFTSTART_MODE)(unsigned short mode, unsigned short number, unsigned short restartdelay);
typedef void (__stdcall *SA4_SET_SOFTSTART_LEVEL)(unsigned short index, unsigned short level);
typedef void (__stdcall *SA4_CONTROL_COMMAND)(unsigned short head, unsigned short axis, unsigned short data);
typedef void (__stdcall *SA4_SET_ROT_CENTER)(long center_x, long center_y);
typedef void (__stdcall *SA4_AUTO_CHANGE_POS)(long start);
typedef short (__stdcall *SA4_GET_VALUE)(unsigned short signal);
typedef short (__stdcall *SA4_STORE_ON_MMC)(void);
typedef unsigned short (__stdcall *SA4_GET_SERIAL_NUMBER)(void);
typedef void (__stdcall *SA4_MEASUREMENT_STATUS)(unsigned short *busy, unsigned short *position);
typedef void (__stdcall *SA4_CLEAR_LIST)(void);
typedef void (__stdcall *SA4_SET_CHAR_TABLE)(unsigned short ch, long listpos);
typedef void (__stdcall *SA4_TIME_UPDATE)(void);
typedef void (__stdcall *SA4_SET_SERIAL)(long no);
typedef void (__stdcall *SA4_LIST_NOP)(void);
typedef void (__stdcall *SA4_SET_END_OF_LIST)(void);
typedef void (__stdcall *SA4_JUMP_ABS)(short x, short y);
typedef void (__stdcall *SA4_JUMP_ABS_3D)(short x, short y, short z);
typedef void (__stdcall *SA4_MARK_ABS)(short x, short y);
typedef void (__stdcall *SA4_MARK_ABS_3D)(short x, short y, short z);
typedef void (__stdcall *SA4_JUMP_REL)(short dx, short dy);
typedef void (__stdcall *SA4_JUMP_REL_3D)(short dx, short dy, short dz);
typedef void (__stdcall *SA4_MARK_REL)(short dx, short dy);
typedef void (__stdcall *SA4_MARK_REL_3D)(short dx, short dy, short dz);
typedef void (__stdcall *SA4_WRITE_8BIT_PORT_LIST)(unsigned short value);
typedef void (__stdcall *SA4_WRITE_DA_1_LIST)(unsigned short value);
typedef void (__stdcall *SA4_WRITE_DA_2_LIST)(unsigned short value);
typedef void (__stdcall *SA4_WRITE_DA_X_LIST)(unsigned short x, unsigned short value);
typedef void (__stdcall *SA4_SET_OFFSET_LIST)(short xoffset, short yoffset);
typedef void (__stdcall *SA4_LONG_DELAY)(unsigned short value);
typedef void (__stdcall *SA4_LASER_ON_LIST)(unsigned short value);
typedef void (__stdcall *SA4_SET_JUMP_SPEED)(double speed);
typedef void (__stdcall *SA4_SET_MARK_SPEED)(double speed);
typedef void (__stdcall *SA4_SET_LASER_DELAYS)(short ondelay, short offdelay);
typedef void (__stdcall *SA4_SET_SCANNER_DELAYS)(unsigned short jumpdelay, unsigned short markdelay, unsigned short polydelay);
typedef void (__stdcall *SA4_SET_LIST_JUMP)(long position);
typedef void (__stdcall *SA4_LIST_CALL)(long position);
typedef void (__stdcall *SA4_LIST_RETURN)(void);
typedef void (__stdcall *SA4_Z_OUT_LIST)(short z);
typedef void (__stdcall *SA4_SET_STANDBY_LIST)(unsigned short half_period, unsigned short pulse);
typedef void (__stdcall *SA4_TIMED_JUMP_ABS)(short x, short y, double time);
typedef void (__stdcall *SA4_TIMED_MARK_ABS)(short x, short y, double time);
typedef void (__stdcall *SA4_TIMED_JUMP_REL)(short dx, short dy, double time);
typedef void (__stdcall *SA4_TIMED_MARK_REL)(short dx, short dy, double time);
typedef void (__stdcall *SA4_SET_LASER_TIMING)(unsigned short halfperiod, unsigned short pulse1, unsigned short pulse2, unsigned short timebase);
typedef void (__stdcall *SA4_SET_WOBBEL)(unsigned short amplitude, double frequency);
typedef void (__stdcall *SA4_SET_FLY_X)(double kx);
typedef void (__stdcall *SA4_SET_FLY_Y)(double ky);
typedef void (__stdcall *SA4_WRITE_IO_PORT_LIST)(unsigned short value);
typedef void (__stdcall *SA4_SET_WAIT)(unsigned short value);
typedef void (__stdcall *SA4_SIMULATE_EXT_START)(short delay, short encoder);
typedef void (__stdcall *SA4_SET_PIXEL_LINE)(unsigned short pixelmode, unsigned short pixelperiod, double dx, double dy);
typedef void (__stdcall *SA4_SET_PIXEL)(unsigned short pulswidth, unsigned short davalue, unsigned short dummy);
typedef void (__stdcall *SA4_SET_EXTSTARTPOS_LIST)(long position);
typedef void (__stdcall *SA4_LASER_SIGNAL_ON_LIST)(void);
typedef void (__stdcall *SA4_LASER_SIGNAL_OFF_LIST)(void);
typedef void (__stdcall *SA4_SET_FIRSTPULSE_KILLER_LIST)(unsigned short fpk);
typedef void (__stdcall *SA4_SET_IO_COND_LIST)(unsigned short mask_1, unsigned short mask_0, unsigned short mask_set);
typedef void (__stdcall *SA4_CLEAR_IO_COND_LIST)(unsigned short mask_1, unsigned short mask_0, unsigned short mask_clear);
typedef void (__stdcall *SA4_LIST_JUMP_COND)(unsigned short mask_1, unsigned short mask_0, long position);
typedef void (__stdcall *SA4_LIST_CALL_COND)(unsigned short mask_1, unsigned short mask_0, long position);
typedef void (__stdcall *SA4_SAVE_AND_RESTART_TIMER)(void);
typedef void (__stdcall *SA4_SET_MATRIX_LIST)(unsigned short i, unsigned short j, double mij);
typedef void (__stdcall *SA4_SET_CONTROL_MODE_LIST)(unsigned short mode);
typedef void (__stdcall *SA4_SET_DEFOCUS_LIST)(short value);
typedef void (__stdcall *SA4_SET_EXT_START_DELAY_LIST)(short delay, short encoder);
typedef void (__stdcall *SA4_SET_WOBBEL_XY)(unsigned short long_wob, unsigned short trans_wob, double frequency);
typedef void (__stdcall *SA4_CALCULATE_FLY)(unsigned short direction, double distance);
typedef void (__stdcall *SA4_SELECT_COR_TABLE_LIST)(unsigned short heada, unsigned short headb);
typedef void (__stdcall *SA4_SET_FLY_ROT)(double resolution);
typedef void (__stdcall *SA4_FLY_RETURN)(short x, short y);
typedef void (__stdcall *SA4_SET_TRIGGER)(unsigned short sampleperiod, unsigned short channel1, unsigned short channel2);
typedef void (__stdcall *SA4_ARC_REL)(short dx, short dy, double angle);
typedef void (__stdcall *SA4_ARC_ABS)(short x, short y, double angle);
typedef void (__stdcall *SA4_TIME_FIX)(void);
typedef void (__stdcall *SA4_MARK_TIME)(unsigned short part, unsigned short mode);
typedef void (__stdcall *SA4_MARK_DATE)(unsigned short part, unsigned short mode);
typedef void (__stdcall *SA4_MARK_SERIAL)(unsigned short mode, unsigned short digits);


#endif // RTCSA4DLL_TYPE
