// ALIData.h
//
//////////////////////////////////////////// 

#ifndef CALIDATA
#define CALIDATA


#include "afx.h"   
#include "afxdlgs.h"

#include "LyrArray.h"


class CAliData
{    
// Attributes
public:
	int m_iProgItems,
		m_iProgLayers;
//	long	m_lMXStfld,
//			m_lMYStfld,
//			m_lMFldSize;
//	CString m_sFixName;
//	int	m_iNgridsize;
//	CString m_sApsName;
//	int	m_iDateType,
//		m_iPVersion,
//		m_iLoanCount,
//		m_iLoanCount1,
//		m_iFilePartNumber,
//		m_iAbortOutput,
//		m_iAbortOutputMask;

	CString m_sRealName;
	
	int m_iNumberLayers;
	
	CString m_sFileTypeRest,		// For full forwards compatibility
	        m_sVersionRest,
	        m_sHeaderRest;
	CLayerArray m_Layers;
	
	//CLayerIO m_aLayerIO[10];
	
	//int m_aiProColor[16];   
	
	//CItemArray m_Items;
	
	int	m_bValidFile;
	
	int m_iCurrentLayer,
		m_iCurrentItem;        
		
	long m_lBase;
	
	CString m_sPathName,
			m_sFileTitle,
			m_sFileName;
			
	WINDOWPLACEMENT	m_ItemInfoPlacement;			
	
private:
	CString m_sDefaultFile,
			m_sNewFile,
			m_sLastFile;
			
protected:
	
// Operators
public:
	CAliData ();       
	void Initialize (CString Default, CString New, long lBase);
	
	
	int FileOpen(CString sFileName = "");
	void FileSaveAs(void);
	void FileSave (void);
	
	int ValidFileName (CString sFileName);
	int GetLastFile(const char *filename);			// Loads last file name the user had open
	int SaveLastFile(const char *filename);			// Save the last file name the user had open
	
	void LoadData(CString sFileName); 
	void SaveData(CString sFileName);
	
	CString GetItemText (int iLayer, int iItem);
	CString GetItemText (void);
	void GetFirstItem (void);
	
	void NxItem(void);							// Advances to next item
	void NxLayer(void);							// Advances to next layer
	void PrItem(void);							// Backs to previous item
	void PrLayer(void);							// Backs to previous layer
	
	CItem* GetActiveItem(void);
	
	void ItemInfo(int iLayer, int iItem);
	void ItemInfo(void);                
	
	void MarkIO(void);
	void MarkIO(int iLayer, int iItem);
	
	void ObjLas(void);
	void ObjLas(int iLayer, int iItem);
	
	int SetTriState(int bit, int mask);
	
	void NewObject(void);
	void CreateNewFile(void);
};                      

#endif

