// AliImporter.h
//
// Header file for the CAliImporter class
////////////////////////////////////////////////
/*** 1.0042 DAN 30.6.98 ALI IMPORTER ***/

#ifndef CALIIMPORTER
#define CALIIMPORTER

#include <stdio.h>
#include "WSData.h"

class CAliImporter
{
// Attributes
private:
	FILE	*m_fp;
	CWSData	*m_pData;

	// Layer / Item #
	long	m_lItemMax;
	long	m_lLayerMax;

	// Prolase version #
	long	m_lVersion;

	// Dummy Variable
	long	m_lDummy;

	long	m_lLayerNum;
	long	m_lItemNum;

	long	m_lDateType;

	// 301 covers limits of old program
	long	m_alOldPos[301][301];

	// End of File flag
	BOOL	m_bEOF;

	/*** 1.0056 19.8.98 IMPORTER FIXES ***/
#ifdef _UNICODE
	TCHAR	m_cDriveLetter;
#else
	char	m_cDriveLetter;
#endif
	/*************************************/

	//// 1.1177 PAT 14.08.06 LOF GRAPHIC IMPORTER ////
	CStdioFile *m_pLogFile;
	BOOL m_bLogFileActive;
	//// 1.1177 //////////////////////////////////////

// Operators
public:
	// Construction / Destruction
	CAliImporter();
	~CAliImporter();


	/*** 1.0056 19.8.98 IMPORTER FIXES ***/
	CString ImportFile(CString sFileName, CWSData *pData);
	CString ImportFile(CWSData *pData);

	void SerializeAliFile(CString sNewFileName);

	
	CString ConvertMaterialFile(CString sApsFile);
	CString ConvertFixtureFile(CString sFixFile);
	/*************************************/


private:
	void InitializeWSData(void);
	void ReadHeader(void);

	long ReadLong(void);
	CString ReadString(void);
	SHORT ReadSHORT(void);

	void ReadLayer(CWSData *pLayer);
	BOOL ReadItem(CWSData *pData);

	void ReadColors(void);

	void SetDataLinks(CWSData *pData);


};

#endif