// Header file for XXX file constants
//
// American LaserWare, Inc
// Pat Summers
// 24 AUG 1997
//
///////////////////////////////////////////////////////////

// filecons.h

#ifndef FILE_CONSTANTS
#define FILE_CONSTANTS

// Versions types
// Initial versions 30 OCT 97
#define VER_ALG_0				0
#define VER_ALF_0				0

// Version settings
#define VER_ALG					VER_ALG_0
#define VER_ALF					VER_ALF_0

// ProLase File Types
#define WS_FT_PROLASE			1
#define WS_FT_PREF				2
#define WS_FT_CONFIG			3
#define	WS_FT_MATERIAL			4
#define	WS_FT_OBJECT			5
#define	WS_FT_FIXTURE			6

// ProLase File Extensions
#define WS_FE_PROLASE			_T("LAZ")
#define WS_FE_PREF				_T("PRE")
#define	WS_FE_CONFIG			_T("CFG")
#define	WS_FE_MATERIAL			_T("MAT")
#define	WS_FE_OBJECT			_T("OB2")
#define WS_FE_FIXTURE			_T("FIX")

// ProLase File Descriptions
#define WS_FD_PROLASE			_T("ProLase Document File")
#define WS_FD_PREF				_T("ProLase Preference File")
#define	WS_FD_CONFIG			_T("ProLase Configuration File")
#define	WS_FD_MATERIAL			_T("Prolase Material File")
#define	WS_FD_OBJECT			_T("ProLase Object File")
#define WS_FD_FIXTURE			_T("ProLase Fixture")

// Copyright notice
//// PS090611A UPDATE COPYRIGHT FOR ECONOLASE ////
//	#define COPY_NAME		"* Copyright American LaserWare, Inc. "
#define COPY_COPY		_T("* Copyright ")
#define COPY_NAME		_T("American Laserware, Inc.")
//// PS090611A ///////////////////////////////////
#define COPY_YEAR		_T("1998")
#define COPY_RIGHTS		_T(" All rights reserved *")

// Define length of all file comments
#define WS_FC_SIZE				16
// Define file comments
#define WS_FC_FILEID			_T("*FILE ID********")
#define WS_FC_VERSION			_T("*VERSION********")
#define WS_FC_TIMESTAMP			_T("*TIME STAMP*****")
#define WS_FC_THUMB				_T("*THUMBNAIL******")
#define WS_FC_HEADER			_T("*HEADER*********")
#define WS_FC_VECTORS			_T("*VECTORS********")
#define WS_FC_NUMSETS			_T("*SETS***********")
#define WS_FC_SETNUMBER			_T("*SET NUMBER*****")
#define WS_FC_NUMCHAR			_T("*CHARS**********")
#define WS_FC_ORDINAL			_T("*ORDINAL********")
#define WS_FC_END				_T("*END OF FILE****")

#define WS_FC_PREF				_T("*WS PREF FILE***")



// Define default file names
#define	WSFILE_DEF_CALDATA_POWER	_T("Default_Power.CAL")
#define WSFILE_DEF_CALDATA_FREQ		_T("Default_Freq.CAL")
#define	WSFILE_DEF_CALDATA_FOCUS	_T("Default_Focus.CAL")

#endif

