// Header file for the CFillData class
//
// FillData.h

//// PS091029A SIMPLE TEXT RTF ////
//// PS091029A ////////////////////

// This class is the data structure for holding data
// parameters for generating a hatch fill

#ifndef CFILLDATA
#define CFILLDATA

#include <afx.h>

#define FILLDATA_2009_10_27			0

#define VER_FILLDATA				FILLDATA_2009_10_27


const unsigned short FILLDATA_MAX_HATCHES				=	5;

class CFillData : public CObject
{

	DECLARE_SERIAL( CFillData )

// Attributes
public:
	// Version info
	UINT m_nVersion;

	long m_lAngle;
	unsigned short m_nNumHatches;
	long m_alAngles[FILLDATA_MAX_HATCHES];
	long m_lSpacing;
	long m_lBeamWidth;
	long m_lItalic;
	long m_lHeight;
	double m_dXComp;
	BOOL m_bMirrorX;
	BOOL m_bMirrorY;
	unsigned short m_nArcPolyLength;
	unsigned short m_nArcResStyle;
	BOOL m_bBiDir;
	unsigned short m_nInterlace;

public:
	CFillData(void);
	~CFillData(void);

	void Init(void);
	void operator =( const CFillData& src );
	BOOL operator ==( const CFillData& src );
	BOOL operator !=( const CFillData& src );
    void Serialize( CArchive& ar );

};

#endif // CFILLDATA


