// GHatch.h
//
// Header file for the CGHatch class
///////////////////////////////////////////////
#ifndef CGHATCH
#define CGHATCH

#include <afx.h>
#include <afxwin.h>

#ifdef _ALIUSE
	#include "..\GLibrary\GLibrary.h"
#else
	#include "GLibrary.h"
#endif

#define HF_TEMP_FILE	"Fill.tmp"

#define HF_SIZE 1000

#define STATE_OFF	0
#define STATE_ON	1

#ifndef PI
	#define PI	3.14159265359
#endif

class CGHatch : public CObject
{

// Attributes
public:

	// Fill information
	UINT	m_bTTFilled;		// True Type filled font
	long	m_lFillSpacing;		// Fill Spacing
	long	m_lFillAngle;		// Fill Angle
	long	m_lBeamWidth;		// Beam Width


	CDC *m_pMemDC;
	CBitmap *m_pMemBitmap,
			*m_pTempBitmap;
	CBrush	*m_pTempBrush;
	CPen	*m_pTempPen;
	CPen	*m_pBeamPen;

	int m_iSize;

	COLORREF	m_crBackGround;

	int		m_iMinX,
			m_iMaxX,
			m_iMinY,
			m_iMaxY;

	CString m_sFont;

	// conversion to size parameter
	long double	m_ldCharRatio;
	// X compression
	long double m_ldXComp;

	// Pointer to the fill cyclopedia
	CCyclopedia	*m_pFills;



// Operators
public:
	// Contructor / Destructor
	CGHatch(void);
	~CGHatch(void);
	void Init(void);	// Initiallize
	
	// Delete all the fills
	void DeleteFills(void);

	// Creates a memory DC for drawing and computing the hatch fill of
	// an object that is drawn using the windows path feature
	void CreateMemDC(CDC *pDC, int iSize, int iBeamWidth);

	// Destroys and deallocates all items associated with a 
	// memory device context
	void DestroyMemDC();

	void DrawFilledChar(CDC *pDC, long *pSymbol);

	int DrawHatch(long double ldHatchSpacing, int iAngle, FILE *fp);

	CGSymbol *FillChar(CDC *pDC, long lHeight, long double ldXComp, long *pSymbol, long lFillAngle, long lFillSpacing, long lBeamWidth);

	int Round(long double ldIn);
};



#endif //CGHATCH