// LaserEnable,h

//// 1.0917 PAT 03.08.04 LASER ENABLE SIGNAL ////
// Added this file
//// 1.0917 /////////////////////////////////////

//// 1.1041 PAT 10.08.05 MULTITHREAD SERVER LASER ENABLE BUG ////
// Modified this file
//// 1.1041 /////////////////////////////////////////////////////

// This file defines the LaserEnableOffTimerTCF

//// PS090304A TRANSLATOR CLASS EXCISING ////
//	//// JT080501A AfxMessageBox translation - aiming for consistency ////
//	#include "Translator.h"
//	//// JT080501A ////
//// PS090304A //////////////////////////////
#include "GlobalData\Language.h"


//// PS090520A REPLACE AFXMESSAGEBOX ////
#include ".\GlobalData\ALI_Lib.h"
// All AfxMessageBox calls replaced by ALI_Lib::MessageBox()
//// PS090520A //////////////////////////


UINT LaserEnableOffTCF(LPVOID pParam)
{
	UINT nRetCode = 0;
	

	CMark *pMark = (CMark *)pParam;
	CWSTimer *pTimer = NULL;
	double dSeconds;
	HANDLE hMutex = NULL;
	DWORD dwWaitResult;
	int iReleaseResult = 0;

	if (pMark == NULL)
	{
		return nRetCode;
	}
	
	hMutex = pMark->m_hLaserEnableOffTimingMutex;
	if (hMutex == NULL)
	{
		return nRetCode;
	}

	pTimer = &(pMark->m_LaserEnableOffTimer);
	if (pTimer->IsReady() != TRUE)
	{
		return nRetCode;
	}

	nRetCode = 1;
	
	// For the duration of the mark engine
	while (pMark->m_bLaserEnableThreadActive)
	{
		// Block until main thread is ready
		// to start Laser Enable Off timing
//		TRACE(_T("MUTEX Blocking - LaserEnable Thread ID= 0x%X    HANDLE = 0x%X\n"), AfxGetThread()->m_nThreadID, AfxGetThread()->m_hThread);
		dwWaitResult = WaitForSingleObject(pMark->m_hLaserEnableOffTimingMutex, INFINITE);
//		TRACE(_T("Laser Enable Thread GOT MUTEX!\n"));
		switch (dwWaitResult)
		{
		case WAIT_OBJECT_0:
			pMark->m_iLaserEnableOffTimingMutexCount++;
//			TRACE(_T("Laser Enable Timing Mutex Count = %d\n"), pMark->m_iLaserEnableOffTimingMutexCount);

			// Are we waiting to turn Laser Enable off?
			if (pMark->m_bLaserEnableOffTimingOn == TRUE)
			{
//				TRACE(_T("Laser Enable Thread - m_bLaserEnableOffTimingOn = TRUE\n"));
							// Check for timeout
				pTimer->GetTimingSeconds(&dSeconds);
//				TRACE(_T("Laser Enable Thread - Timer = %f\n"), dSeconds);
				if (dSeconds >= pMark->m_pConfig->m_dLaserEnableOffTime)
				{
					// Time is up...
					// Stop timing now
					pTimer->StopTiming();
					// Deactivate the Laser Enable signal
					pMark->SetLaserEnable(FALSE);
					// Enforce the minimum down time
					pTimer->DelaySeconds(pMark->m_pConfig->m_dLaserEnableCycleDelay, NULL);

					pMark->m_bLaserEnableOffTimingOn = FALSE;
		
//					TRACE(_T("Laser Enable timeout SHUTDOWN!!! ***********\n"));
				}
			}
			else
			{
//				TRACE(_T("Laser Enable Thread - m_bLaserEnableOffTimingOn = FALSE\n"_T();
				pTimer->StopTiming();
			}
			break;
		case WAIT_TIMEOUT:
			//// JT080501A AfxMessageBox translation - aiming for consistency ////
			//Translator::M Box("Timeout???");
			ALI_Lib::MessageBox(CLanguage::Translate(_T("Timeout???") ));
			//// JT080501A ////
			break;
		case WAIT_ABANDONED:
			//// JT080501A AfxMessageBox translation - aiming for consistency ////
			//Translator::M Box("Abandoned???");
			ALI_Lib::MessageBox(CLanguage::Translate(_T("Abandoned???") ));
			//// JT080501A ////
			break;
		}
//		TRACE(_T("MUTEX Releasing - LaserEnable Thread ID= 0x%X    HANDLE = 0x%X\n"), AfxGetThread()->m_nThreadID, AfxGetThread()->m_hThread);
		int iRelease = ReleaseMutex(pMark->m_hLaserEnableOffTimingMutex);
//		TRACE(_T("\tRelease = %i\n"), iRelease);

		pMark->m_iLaserEnableOffTimingMutexCount--;
//		TRACE(_T("Laser Enable Timing Mutex Count = %d\n"), pMark->m_iLaserEnableOffTimingMutexCount);

		Sleep(0);
	}
	nRetCode = 11;

	return nRetCode;
}// LaserEnableOffTimingTCF
