// Header file for CldGVector class
//
// American LaserWare, Inc
// Pat Summers
// 19 AUG 1997
//
//	Serves to hold all the possible data required for any
//	relative vector in long doubles.  This is typically
//	used when scaling the lGVector data from the CLongList.
//  Member function facilitate modifying the data as long
//	doubles or loading, saving, or retrieving the data cast
//	from longs to long doubles.
///////////////////////////////////////////////////////////

// ldgvecto.h

#ifndef CLDGVECTOR
#define CLDGVECTOR

// lGVector class specific constant definitions
#define LDGV_SIZE_DEF				VG_VS_STOP
#define LDGV_COM_DEF				VG_VC_STOP
#define LDGV_VALUE_DEF				0

// Include header files required for members
#include "vgconst.h"
#include "longlist.h"

class CldGVector : public CObject
{

	DECLARE_SERIAL (CldGVector)
		
//Attributes
public:
	int 
		m_iSize;
	long
		m_lCommand;
	long double 
		m_ldX,
		m_ldY,
		m_ldI,
		m_ldJ;

// Implementations
public:
	CldGVector();						// Constructor
	CldGVector(CldGVector&);			// Copy Constructor
	~CldGVector();						// Destructor
	void Init(void);					// Initializes members
	void Serialize(CArchive&);			// Load / Save routines
	int GetSize(void);					// Returns the vector size (long doubles)
	long GetCommand(void);				// Returns the command value
	long double GetX(void);				// Returns the X value
	long double GetY(void);				// Returns the Y value
	long double GetI(void);				// Returns the I value
	long double GetJ(void);				// Returns the J value
	int GetVector(CLongList *, long);	// Obtains a vector from a CLongList
	long Add(CLongList *, long);		// Inserts a vector into a CLongList
	void SetVector(long=0, long=0, long=0, long=0, long=0);
										// Assigns values to a vector
	void SetVector(long=0, long double=0, long double=0,
					long double=0, long double=0);
										// Assigns values to a vector
//Operators
public:
	void operator =(const CldGVector&);	// Assignment operator
	void operator =(const CObject&);	// Assignment operator

};			            

#endif

