// Header file for ClGVector class
//
// American LaserWare, Inc
// Pat Summers
// 19 AUG 1997
//
//	Serves to hold all the possible data required for any
//	vector information of a symbol found in the CLongList.
//  Member function facilitate retrieving, loading, saving,
//	and modifying that data.
///////////////////////////////////////////////////////////

// lgvector.h

#ifndef CLGVECTOR
#define CLGVECTOR

// lGVector class specific constant definitions
#define GV_SIZE_DEF				VG_VS_STOP
#define GV_COM_DEF				VG_VC_STOP
#define GV_VALUE_DEF			0

// Include header files required for members
#include "vgconst.h"
#include "longlist.h"

class ClGVector : public CObject
{

	DECLARE_SERIAL (ClGVector)
		
//Attributes
public:
	int 
		m_iSize;
	long 
		m_lCommand,
		 m_lX,
		 m_lY,
		 m_lI,
		 m_lJ;

// Implementations
public:
	ClGVector(void);					// Constructor
	ClGVector(ClGVector&);				// Copy Constructor
	~ClGVector(void);					// Destructor
	void Init (void);					// Initialize members
	void Serialize(CArchive&);			// Load / Save routines
	int GetSize(void);					// Returns the vector size (in longs)
	long GetCommand(void);				// Returns the vector command
	long GetX(void);					// Returns the X value
	long GetY(void);					// Returns the Y value
	long GetI(void);					// Returns the I value
	long GetJ(void);					// Returns the J value
	int GetVector(CLongList *, long);	// Obtains a vector from a CLongList
	long Add(CLongList *, long);		// Inserts a vector into CLongList
	void SetVector(long=0, long=0, long=0, long=0, long=0);
										// Assigns values to a vector
	void SetVector(long=0, long double=0, long double=0,
					long double=0, long double=0);
										// Assigns values to a vector

// Operators
public:
	void operator=(const ClGVector&);	// Assignment operator
	void operator=(const CObject&);		// Assignment operator

};			

#endif


