// LM50Cal_Constants.h

// This file contains definitions of constants used
// in the CLM50 and CLM50CalTable classes
//
// Pat Summers
// American LaserWare, Inc.

//// REV S003 - 20020409 - CALIBRRATION ////
// Intoduced this class/file.
//// REV S003 ////////////////////////////////

#ifndef LM50CAL_CONSTANTS
#define LM50CAL_CONSTANTS

const int		LM50CAL_TABLE_MAX				=	150;
const double	LM50CAL_TABLE_DEFAULT_YINT		=	5.00;
const double	LM50CAL_TABLE_DEFAULT_SLOPE		=	0.200;

//// REV L006 - 20020708 - CALIBRATION FIX 1 ////
const double	LM50CAL_TABLE_MAXDEVIATION		=	3.000;
//// REV L006 ///////////////////////////////////

//// REV L008 - 20021015 - DEFAULT RAMPING ////
//	const BOOL		LM50CAL_ACTIVEFLAG_DEFAULT		=	0;
const BOOL		LM50CAL_ACTIVEFLAG_DEFAULT		=	TRUE;
//// REV L008 /////////////////////////////////

const double	LM50CAL_TOLERANCE_MIN			=	0.001;
const double	LM50CAL_TOLERANCE_MAX			=	5.000;
const double	LM50CAL_TOLERANCE_DEFAULT		=	0.100;

const double	LM50CAL_MAXDELAY_MIN			=	0.0001;
const double	LM50CAL_MAXDELAY_MAX			=	5.0000;
const double	LM50CAL_MAXDELAY_DEFAULT		=	0.1000;

const int		LM50CAL_SAMPLES_MAX				=	10;

const double	LM50CAL_CORRECTION_ORDER_2		=	+0.0031;
const double	LM50CAL_CORRECTION_ORDER_1		=	+0.9575;
const double	LM50CAL_CORRECTION_ORDER_0		=	-0.0958;


#endif	// LM50CAL_CONSTANTS
