// PlotterDrv.h
//
// Header file for the CPlotterDrv class
////////////////////////////////////////////////////
/// 1.0320 DAN 8/1/00 PLOTTER MARKER DRIVER ADDITIONS ///
////1.0320///////////////////////////////////////////////

/// 1.0352 DAN 1/15/01 ULS MARKER BITMAP MARKING ///
#include "Display.h"
////1.0352//////////////////////////////////////////

#ifndef CPLOTTERDRV
#define CPLOTTERDRV

#define ULS_BLACK	0
#define ULS_RED		1
#define ULS_GREEN	2
#define ULS_YELLOW	3
#define ULS_BLUE	4
#define ULS_MAGENTA	5
#define ULS_CYAN	6
#define ULS_ORANGE	7

class CPlotterDrv
{
// Attributes
public:
protected:
	// The plotter device context
	//CDC	m_PlotDC;
	CDC *m_pPlotDC;
	CString	m_sPlotterName;
	/// 1.0322 DAN 8/22/00 PLOTTER MARKER DRIVER ADDITIONS ///
	BOOL	m_bPlotterSelected;
	////1.0322////////////////////////////////////////////////

	CPen *m_pPen;

	COLORREF	m_Colors[8];


	UINT	m_nArcPolyLength;
	UINT	m_nArcRes;

	/// 1.0352 DAN 1/15/01 ULS MARKER BITMAP MARKING ///
	BOOL	m_bSimulate;

	CDC	*m_pDC;
	CDisplay	*m_pDisplay;
	////1.0352//////////////////////////////////////////


	/// 1.0352 DAN 1/15/01 ULS MARKER BITMAP MARKING ///
	CItem *m_pItem;
	////1.0352//////////////////////////////////////////

	//// 1.0495 PAT 07.02.01 PLOTTER XFORM FIX ////
	BOOL
		m_bFieldSwapXY,
		m_bFieldNegateX,
		m_bFieldNegateY;
	//// 1.0495 ///////////////////////////////////

	//// 1.0497 PAT 15.02.01 ULS PLOTTER PATCH # 1 ////
public:
	int
		m_iPrintJobs;
	CString
		m_sDocName,
		m_sLayerName;
	BOOL
		m_bInDoc,
		m_bInPage;

	//// 1.0497 ///////////////////////////////////////

// Operators
public:
	// Construction / Destruction
	CPlotterDrv();
	~CPlotterDrv();

	//// 1.0497 PAT 15.02.01 ULS PLOTTER PATCH # 1 ////
	void Init(void);
	//// 1.0497 ///////////////////////////////////////

	// Obtain a plotter DC
	BOOL SelectPlotter(void);

	// Start a printing session
	BOOL StartMark(void);
	// End a printing session
	BOOL EndMark(void);
	//// 1.0497 PAT 15.02.01 ULS PLOTTER PATCH # 1 ////
	BOOL AbortMark(void);
	// Aborts a current print job
	void InitMark(void);
	// Inits flags/counters at the start of mark session
	void SetDeviceScaling(void);
	// 
	//// 1.0497 ///////////////////////////////////////

	// Marking Commands
	void MarkTestPattern(void);

	void MoveTo(long lX, long lY);
	void LineTo(long lX, long lY);

	void SetPen(UINT nColor, UINT nWidth);

	/// 1.0352 DAN 1/15/01 ULS MARKER BITMAP MARKING ///
	void SimulateVectors (long *, short *, CDC *, CDisplay *);
	////1.0352//////////////////////////////////////////
	void MoveGalvos (short *, short *, short *, short *, long *, short *);

	void AddArc(long *lVecInfo, short *siVecInfo);
	BOOL GetNextArcSegment(long *lVecInfo, short *siVecInfo, short *siX, short *siY, UINT m_nArcPolyLength);

	/// 1.0340 DAN 11/25/00 PLOTTER MARKER DRIVER ADDITIONS 2 ///
	void SetPlotterName(CString sName);
	CString GetPlotterName(void);
	////1.0340///////////////////////////////////////////////////

	/// 1.0352 DAN 1/15/01 ULS MARKER BITMAP MARKING ///
	void SetItem (CItem *pItem);

	void MarkBitmap (long double ldXCur, long double ldYCur);
	void SimulateBitmap (long double ldXCur, long double ldYCur, CDC *pDC, CDisplay *pDisplay);
	////1.0352//////////////////////////////////////////

	//// 1.0495 PAT 07.02.01 PLOTTER XFORM FIX ////
	void TransformXY(long *plX, long *plY);
	//// 1.0495 ///////////////////////////////////

protected:
};

#endif // CPLOTTERDRV

