// Pos.h
//
// Header file for the CPos class
//////////////////////////////////
#ifndef POS
#define POS

// This class is now derived from CObject
// and has been made serializable
#include <afx.h>

#ifndef PI
	#define PI	3.14159265359
#endif

// Include version info
#ifdef _ALIUSE
	#include "..\Versions\versions.h"
#else
	#include "versions.h"
#endif

class CPos : public CObject
{
	DECLARE_SERIAL(CPos)

// Attributes
public:
	long	m_lX,
			m_lY;

	long double	m_ldRad,
				m_ldAng;

// Operators
public:
	// Construction / Destruction
	CPos(void);
	CPos(long lX, long lY);
	// Copy Constructor
	CPos( const CPos& Src );
	CPos(long double ldRad, long double ldAng);

	~CPos(void);

	
	// Serialization
	void Serialize( CArchive& ar );


	// Coordinate Transformation
	void RtoP(void);						// Rectangular to Polar
	void PtoR(void);						// Polar to Rectangular

	// Assignment / Mathematical operations
	void operator =( const CPos& src );		// Sets all values equal

	void operator +=( const CPos& src );	// Adds rectangular coords
	void operator -=( const CPos& src );	// Subs rectangular coords
	
/*** PAT 1 FEB 1998 ***/
	BOOL operator ==( const CPos& src );	// Equivalence
/***/
	
	// Misc. operators
	void SetDegrees (int iDegrees);
	int	 GetDegrees (void);
};

#endif